-- See:
-- Lloyd ALLISON. Models for machine learning and data mining in
--   functional programming.       doi:10.1017/S0956796804005301
--   J. Functional Programming, 15(1), pp.15-32, Jan. 2005 (online 23 Jul 2004)
-- Lloyd ALLISON. Types and classes of machine learning and data mining.
--   ACSC2003, pp.207-215, February 2003.
-- Lloyd ALLISON. A programming paradigm for machine learning, with
--   a case study of Bayesian networks.  ACSC2006, January 2006.
--
-- Author: Lloyd ALLISON
-- This program is free software; you can redistribute it and/or modify it
-- under the terms of the GNU General Public License (GPL) as published by
-- the Free Software Foundation; either version 2 of the License, or (at
-- your option) any later version.  This program is distributed in the hope
-- that it will be useful, but without any warranty, without even the implied
-- warranty of merchantability or fitness for a particular purpose.  See the
-- GNU General Public License for more details.  You should have received a
-- copy of the GNU General Public License with this program; if not, write to:
-- Free Software Foundation, Inc., Boston, MA 02111, USA.

module IP.TSModels (module IP.TSModels) where

import IP.Utilities
import IP.Classes
import IP.Models
import IP.FnModels

               -- estimate a Markov model of order k, a TimeSeries of dataSpace
estMarkov k dataSeries =
  --  scan makes list of input contexts for the predictor function
  let scan (d:ds) context = context : (scan ds (d:context))
      scan []     _       = []
      -- e.g. scan "abcdef" [] -> ["","a","ba","cba","dcba","edcba"]
      contexts = scan dataSeries []  -- NB. each context is "backwards"
  in functionModel2timeSeries (estFiniteListFunction k contexts dataSeries)

-- -------------------------------------------LA--http://www.allisons.org/ll/--
