--Here: Test-harness main program for Student's t-distribution.
--Also see Sci.hs and T.hs.
--Compile tests thus: ghc --make T   (has run under ghc 6.4.1, Feb 2008).

module Main where

import IP.Sci                --defined locally
import qualified IP.T as T   --defined locally; e.g., T.negLogLH, etc.

import Array  --a standard library.
-- For Haskell's 'Array' library, see...
--   http://haskell.org/ghc/docs/latest/html/libraries/array/Data-Array.html


t_data = [-2, -1, 0, 1, 2,  -1, 0, 1,  0,  -10, 10] --a test dataset

main = putStrLn "-- Tests of implementation of Student's t-distribution, LA --"

 >> putStrLn( "t(0,2,4)(0.0) = " ++ show (exp(-T.negLogLH(0,2,4)[0.0])) )
 >> let msv = T.est_MLH_params t_data  --msv, (mean,sigma,nu)
        n   = fromIntegral(length t_data)
    in putStrLn("t MLH = " ++ show msv ++ ", F=" ++ show(exp(T.logF n msv))
        ++ ", negLogLH=" ++ show(T.negLogLH msv t_data) )
 >> let msv = T.est_MML_params prior T.constraint0 t_data
	prior(m,s,v) = 1/(10*s*v)  --not quite proper
	f   = T.fisher n msv
    in putStrLn("t MML = " ++ show msv ++ ", F=" ++ show(exp(T.logF n msv))
        ++ ", negLogLH=" ++ show(T.negLogLH msv t_data)
	++ "\n  F = " ++ show f ++ ", det F = " ++ show(det f)
	)

 >> putStrLn "-- done --"
-- -----------------------------------2/2008--LA--http://www.allisons.org/ll/--
