--Here: Test-harness main program to test module TSModels (TSModels.hs).
--Compile tests thus: ghc --make TSModels
--(has run under ghc 6.4.1, April 2008).

module Main where

import IP.Utilities
import IP.Classes
import IP.Models
import IP.FnModels

import IP.TSModels   -- *

main = let
  seq = [H,T,H,T,H,T, T,H, H,T]    -- mostly HT alternating
  mm0 = estMarkov 0 seq            -- order 0
  mm1 = estMarkov 1 seq            -- order 1
  mm2 = estMarkov 2 seq            -- order 2
  mmm = mixture(Mix fifty50 [mm0, mm1])

  basics tsm =
    putStrLn("tsm is " ++ show tsm)
    >> putStrLn("  prs tsm seq = " ++ show(prs tsm seq)
             ++ " (sum=" ++ show(sum(prs tsm seq)) ++ ")" )

  test n =
    let s = (take n . cycle) seq
        m k = let mm = timeSeries2model (estMarkov k s)
              in ", order=" ++ show k ++ " msgLen=" ++ show(msgBase 2 mm [s])
    in putStrLn( "length=" ++ show n ++ m 0 ++ m 1 ++ m 2 ++ " bits" )

 in putStrLn "-- Test of Time-Series Models for Inductive Programming, LA --\n"

 >> putStrLn("prs (coinByPrH 0.4) [H,T,H,T] = "
     ++ show(prs (coinByPrH 0.4) [H,T,H,T] ))
 >> putStrLn ""

 >> basics mm0
 >> basics mm1
 >> basics mm2
 >> basics mmm
 >> putStrLn ""

 >> test 10
 >> test 100
 >> test 1000

 >> putStrLn "\n-- done --"
-- -------------------------------------------LA--http://www.allisons.org/ll/--
